// EDitDlg.cpp : implementation file
//

/************************************************************************************************

    EDit ED-MS Data Manipulation Software
    Copyright (C) 2004,2005  Shamus Husheer (S.L.G.Husheer.02@cantab.net)
    See Husheer et al, Rapid Commun. Mass Spectrom. (2005) for more details

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


See line 340 for note on "important" sections of code - everything else is windows "housekeeping"

************************************************************************************************/

#include "stdafx.h"
#include "EDit.h"
#include "EDitDlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CEDitDlg dialog



CEDitDlg::CEDitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEDitDlg::IDD, pParent)
	, m_Yaxis(0)
	, m_MZstart(50)
	, m_MZend(700)
	, m_MZnumber(651)
	, m_SCANstart(1)
	, m_SCANend(150)
	, m_SCANnumber(75)
	, m_RETstart(0.05f)
	, m_RETend(7.8f)
	, m_RETnumber(100)
	, m_DimensionVal(FALSE)
	, m_ProcessingVal(FALSE)
	, m_Integrate(TRUE)
	, m_Normalise(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEDitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_Status, m_StatusBar);
	DDX_Radio(pDX, IDC_RadioScan, m_Yaxis);
	DDX_Control(pDX, IDC_Process, m_ProcessingCtrl);
	DDX_Text(pDX, IDC_MZStart, m_MZstart);
	DDX_Text(pDX, IDC_MZEnd, m_MZend);
	DDX_Text(pDX, IDC_MZNumber, m_MZnumber);
	DDX_Text(pDX, IDC_ScanStart, m_SCANstart);
	DDX_Text(pDX, IDC_ScanEnd, m_SCANend);
	DDX_Text(pDX, IDC_ScanNumber, m_SCANnumber);
	DDX_Text(pDX, IDC_RetStart, m_RETstart);
	DDX_Text(pDX, IDC_RetEnd, m_RETend);
	DDX_Text(pDX, IDC_RetNumber, m_RETnumber);
	DDX_Control(pDX, IDC_Dimension, m_DimensionCtrl);
	DDX_Check(pDX, IDC_Dimension, m_DimensionVal);
	DDX_Check(pDX, IDC_Process, m_ProcessingVal);
	DDX_Check(pDX, IDC_Integrate, m_Integrate);
	DDX_Control(pDX, IDC_ScanStart, m_ScanStartCtrl);
	DDX_Control(pDX, IDC_ScanEnd, m_ScanEndCtrl);
	DDX_Control(pDX, IDC_ScanNumber, m_ScanNumberCtrl);
	DDX_Control(pDX, IDC_RetStart, m_RetStartCtrl);
	DDX_Control(pDX, IDC_RetEnd, m_RetEndCtrl);
	DDX_Control(pDX, IDC_RetNumber, m_RetNumberCtrl);
	DDX_Check(pDX, IDC_Normalise, m_Normalise);
}

BEGIN_MESSAGE_MAP(CEDitDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_Process, OnBnClickedProcess)
	ON_BN_CLICKED(IDC_Dimension, OnBnClickedDimension)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RadioScan, OnBnClickedRadioscan)
	ON_BN_CLICKED(IDC_RadioRet, OnBnClickedRadioret)
END_MESSAGE_MAP()


// CEDitDlg message handlers

BOOL CEDitDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
// Init data member
	data.critsec.Lock();

	data.parent=this;

	data.progressname="Waiting...";
	data.total=-1;
	data.present=1;

	data.workerflag=2;		// Complete

	data.inputfilename="testdata.txt";
	data.outputfilename="testdata.csv";
	data.mzmin=m_MZstart;
	data.mzmax=m_MZend;
	data.mznum=m_MZnumber;
	data.numx=m_MZnumber;
	data.scanmin=m_SCANstart;
	data.scanmax=m_SCANend;
	data.scannum=m_SCANnumber;
	data.retmin=m_RETstart;
	data.retmax=m_RETend;
	data.retnum=m_RETnumber;
	data.yaxis=m_Yaxis;
	if(data.yaxis==0) data.numy=data.scannum; else data.numy=data.retnum;
	data.integrate=m_Integrate;
	data.normalise=m_Normalise;

	data.critsec.Unlock();

	OnBnClickedRadioscan();

	SetTimer(1, 100, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEDitDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEDitDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEDitDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CEDitDlg::OnTimer(UINT nIDEvent)
{
	static CString	lasttext;
	if(nIDEvent==1)				// Progress update
	{
		CString text;

		data.critsec.Lock();
		text+=data.progressname;
		if(data.total>0)
		{
			text.AppendFormat(" (%0.02f%%)", 100*data.present/data.total);
		}
		data.critsec.Unlock();

		if(lasttext.Compare(text)!=0)
		{
			lasttext=text;
			m_StatusBar.SetWindowText(text);
		}
		return;
	}
	if(nIDEvent==2)				// Dimensining complete OK
	{
		KillTimer(2);
		data.critsec.Lock();
		m_MZstart=data.mzmin;
		m_MZend=data.mzmax;
		m_MZnumber=data.mznum;
		m_SCANstart=data.scanmin;
		m_SCANend=data.scanmax;
		m_SCANnumber=data.scannum;
		m_RETstart=data.retmin;
		m_RETend=data.retmax;
		m_RETnumber=data.retnum;
		data.critsec.Unlock();
		m_DimensionVal=FALSE;
		UpdateData(FALSE);
		m_DimensionCtrl.SetWindowText("Dimension");
		return;
	}
	if(nIDEvent==3)				// Dimensining failed
	{
		KillTimer(3);
		m_DimensionVal=FALSE;
		UpdateData(FALSE);
		m_DimensionCtrl.SetWindowText("Dimension");
		return;
	}
	if(nIDEvent==4)				// Processing complete OK
	{
		KillTimer(4);
		m_ProcessingVal=FALSE;
		UpdateData(FALSE);
		m_ProcessingCtrl.SetWindowText("Process");
		return;
	}
	if(nIDEvent==5)				// Processing failed
	{
		KillTimer(5);
		m_ProcessingVal=FALSE;
		UpdateData(FALSE);
		m_ProcessingCtrl.SetWindowText("Process");
		return;
	}
	CDialog::OnTimer(nIDEvent);
}

void CEDitDlg::OnBnClickedRadioscan()
{
	m_ScanStartCtrl.SetReadOnly(FALSE);
	m_ScanEndCtrl.SetReadOnly(FALSE);
	m_ScanNumberCtrl.SetReadOnly(FALSE);
	m_RetStartCtrl.SetReadOnly(TRUE);
	m_RetEndCtrl.SetReadOnly(TRUE);
	m_RetNumberCtrl.SetReadOnly(TRUE);
}

void CEDitDlg::OnBnClickedRadioret()
{
	m_ScanStartCtrl.SetReadOnly(TRUE);
	m_ScanEndCtrl.SetReadOnly(TRUE);
	m_ScanNumberCtrl.SetReadOnly(TRUE);
	m_RetStartCtrl.SetReadOnly(FALSE);
	m_RetEndCtrl.SetReadOnly(FALSE);
	m_RetNumberCtrl.SetReadOnly(FALSE);
}

/*************************************************
 Everything prior to this point is essentially "Windows housekeeping"
 The important code (dimension, read, manipulate, write) is below.
 The code is designed to run as a second "thread" so that the GUI does not
 "freeze" - this simply requires the occasional use of critical sections (critsec).
 The code could easily be ported to any other OS as a single-threaded application
**************************************************/

UINT ThreadDimension(LPVOID pParam)
{
	CDataProcessing *data = (CDataProcessing*) pParam;
	if(data!=NULL)
	{
		if(data->GetDimensions()==TRUE)
			data->parent->SetTimer(2, 10, 0);		// Dimensioning complete OK
		else
			data->parent->SetTimer(3, 10, 0);		// Dimensioning failed
	}
	return(0);
}

UINT ThreadProcess(LPVOID pParam)
{
	CDataProcessing *data = (CDataProcessing*) pParam;
	if(data!=NULL)
	{
		if(data->DoFull()==TRUE)
			data->parent->SetTimer(4, 10, 0);		// Processing complete OK
		else
			data->parent->SetTimer(5, 10, 0);		// Processing failed

		data->FreeMem();
	}
	return(0);
}

void CEDitDlg::OnBnClickedDimension()
{
	UpdateData();
	if(m_DimensionVal)
	{
		m_DimensionCtrl.SetWindowText("ABORT");
		data.critsec.Lock();
		data.workerflag=1;		// Working
		data.critsec.Unlock();
		AfxBeginThread(ThreadDimension, &data);
	}
	else
	{
		data.critsec.Lock();
		data.workerflag=-1;		// Quit
		data.critsec.Unlock();
	}
}

void CEDitDlg::OnBnClickedProcess()
{
	UpdateData();
	if(m_ProcessingVal)
	{
		m_ProcessingCtrl.SetWindowText("ABORT");
		data.critsec.Lock();
		data.workerflag=1;		// Working

		data.mzmin=m_MZstart;
		data.mzmax=m_MZend;
		data.mznum=m_MZnumber;
		data.numx=m_MZnumber;
		data.scanmin=m_SCANstart;
		data.scanmax=m_SCANend;
		data.scannum=m_SCANnumber;
		data.retmin=m_RETstart;
		data.retmax=m_RETend;
		data.retnum=m_RETnumber;
		data.yaxis=m_Yaxis;
		if(data.yaxis==0) data.numy=data.scannum; else data.numy=data.retnum;
		data.integrate=m_Integrate;
		data.normalise=m_Normalise;

		data.critsec.Unlock();
		AfxBeginThread(ThreadProcess, &data);
	}
	else
	{
		data.critsec.Lock();
		data.workerflag=-1;		// Quit
		data.critsec.Unlock();
	}
}

BOOL CDataProcessing::GetDimensions()
{
	// Get input file name

	CString filename;
	float	tellpos;

	critsec.Lock();
	workerflag=1;		// Working
	progressname = "Waiting for user input";
	total=-1;
	filename = inputfilename;
	critsec.Unlock();

	static char BASED_CODE infilter[] = "Text Files (*.txt)|*.txt|CSV Files (*.csv)|*.csv|All Files (*.*)|*.*||";

	CFileDialog filebox(TRUE, "*.txt", filename, NULL , infilter);

	filebox.m_ofn.lpstrTitle="Input Data";
	if(filebox.DoModal()==IDOK)
	{
		filename=filebox.GetPathName();
	}
	else
	{
		critsec.Lock();
		workerflag=2;		// Complete
		progressname = "Dimensioning Cancelled";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}

	critsec.Lock();
	if(workerflag<0)
	{
		workerflag=2;		// Complete
		progressname = "Dimensioning Cancelled";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}
	critsec.Unlock();

	// Open input file

	FILE *filehd;

	filehd=fopen(filename, "rt");
	if(filehd==NULL)
	{
		MessageBox(NULL, "Couldn't open input file - aborted!", "Dimensining Error", MB_OK);

		critsec.Lock();
		workerflag=2;		// Complete
		progressname = "Dimensioning Error";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}

	fseek(filehd, 0, SEEK_END);
	tellpos=(float)ftell(filehd);
	fseek(filehd, 0, SEEK_SET);

	critsec.Lock();
	inputfilename = filename;
	progressname = "Dimensioning...";
	total=tellpos;
	present=0;
	critsec.Unlock();

	// Get max x and y values

	float t_mzmin=1e6f, t_mzmax=0, t_scanmin=1e6f, t_scanmax=0, t_retmin=1e6f, t_retmax=0;
	DWORD	t_scannum=0, t_retnum=0;
	int update=0;

	char inputline[1050];
	CString inputstring;

	float xvalue, yvalue, zvalue;

	while(feof(filehd)==0)
	{
		if(update<=0)
		{
			tellpos=(float)ftell(filehd);
			critsec.Lock();
			present=tellpos;

			if(workerflag<0)
			{
				workerflag=2;		// Complete
				progressname = "Dimensioning Cancelled";
				total=-1;
				critsec.Unlock();
				fclose(filehd);
				return(FALSE);
			}
			critsec.Unlock();
			update=1000;			// 1000 lines per update
		}
		update--;

		fgets(inputline,1024,filehd);
		inputstring=inputline;
		if(inputstring.GetLength()>2)
		{
			if(inputstring.Find("Scan")!=-1)
			{
				t_scannum++;
				sscanf(inputline, "Scan\t\t%f", &yvalue);
				if(yvalue<t_scanmin) t_scanmin=yvalue;
				if(yvalue>t_scanmax) t_scanmax=yvalue;
			}
			else if(inputstring.Find("Retention")!=-1)
			{
				t_retnum++;
				sscanf(inputline, "Retention Time\t%f", &yvalue);
				if(yvalue<t_retmin) t_retmin=yvalue;
				if(yvalue>t_retmax) t_retmax=yvalue;
			}
			else if(sscanf(inputline, "%f\t%f", &xvalue, &zvalue)==2)
			{
				if(xvalue<t_mzmin) t_mzmin=xvalue;
				if(xvalue>t_mzmax) t_mzmax=xvalue;
			}
		}
	}

	fclose(filehd);

	critsec.Lock();
	progressname = "Dimensioning Complete";
	total=-1;

	mznum=(DWORD)floor((t_mzmax-t_mzmin)+1.5f);

	mzmin=t_mzmin;
	mzmax=t_mzmax;
	scanmin=t_scanmin;
	scanmax=t_scanmax;
	scannum=t_scannum;
	retmin=t_retmin;
	retmax=t_retmax;
	retnum=t_retnum;

	workerflag=2;		// Complete
	critsec.Unlock();

	return(TRUE);
}

BOOL CDataProcessing::DoFull()
{
	if(ReadFile()==FALSE) return(FALSE);
	if(Manipulate()==FALSE) return(FALSE);
	if(WriteFile()==FALSE) return(FALSE);
	critsec.Lock();
	progressname="Complete";		// Status text = complete
	workerflag=2;					// Signal task completion
	critsec.Unlock();
	return(TRUE);
}

BOOL CDataProcessing::ReadFile()
{
	// Get input file name

	CString filename;
	float	tellpos;

	critsec.Lock();
	workerflag=1;		// Working
	progressname = "Waiting for user input";
	total=-1;
	filename = inputfilename;
	critsec.Unlock();

	static char BASED_CODE infilter[] = "Text Files (*.txt)|*.txt|CSV Files (*.csv)|*.csv|All Files (*.*)|*.*||";

	CFileDialog filebox(TRUE, "*.txt", filename, NULL , infilter);

	filebox.m_ofn.lpstrTitle="Input Data";
	if(filebox.DoModal()==IDOK)
	{
		filename=filebox.GetPathName();
	}
	else
	{
		critsec.Lock();
		workerflag=2;		// Complete
		progressname = "Processing Cancelled";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}

	critsec.Lock();
	if(workerflag<0)
	{
		workerflag=2;		// Complete
		progressname = "Processing Cancelled";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}
	critsec.Unlock();

	// Open input file

	FILE *filehd;

	filehd=fopen(filename, "rt");
	if(filehd==NULL)
	{
		MessageBox(NULL, "Couldn't open input file - aborted!", "Processing Error", MB_OK);

		critsec.Lock();
		workerflag=2;		// Complete
		progressname = "Processing Read Error";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}

	critsec.Lock();
	progressname = "Allocating memory...";
	total=-1;
	FreeMem();
	xvalues = new float[numx];
	yvalues = new float[numy];
	ycounts = new DWORD[numy];
	zvalues = new float[numx*numy];
	zcounts = new DWORD[numx*numy];
	if((xvalues==NULL)||(yvalues==NULL)||(zvalues==NULL)||(zcounts==NULL))
	{
		workerflag=2;		// Complete
		progressname = "Processing Memory Error";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}
	critsec.Unlock();

	float start, xstepsize, ystepsize;
	DWORD x,y;

	start = mzmin;
	xstepsize = (mzmax-mzmin)/((float)numx-1);
	for(x=0; x<numx; x++)
	{
		xvalues[x]=start+(xstepsize*((float)x));
	}

	if(yaxis==0)
	{
		start = scanmin;
		ystepsize = (scanmax-scanmin)/((float)numy-1);
	}
	else
	{
		start = retmin;
		ystepsize = (retmax-retmin)/((float)numy-1);
	}
	for(y=0; y<numy; y++)
	{
		yvalues[y]=start+(ystepsize*((float)y));
		ycounts[y]=0;
	}

	for(y=0; y<numy; y++)
	{
		for(x=0; x<numx; x++)
		{
			zvalues[(numx*y)+x]=0;
			zcounts[(numx*y)+x]=0;
		}
	}

	fseek(filehd, 0, SEEK_END);
	tellpos=(float)ftell(filehd);
	fseek(filehd, 0, SEEK_SET);

	critsec.Lock();
	inputfilename = filename;
	progressname = "Reading...";
	total=tellpos;
	present=0;
	critsec.Unlock();

	// Read x,y,z values

	int update=0;

	char inputline[1050];
	CString inputstring;

	float xvalue=xvalues[0], yvalue=yvalues[0], zvalue=0;

	while(feof(filehd)==0)
	{
		if(update<=0)
		{
			tellpos=(float)ftell(filehd);
			critsec.Lock();
			present=tellpos;

			if(workerflag<0)
			{
				workerflag=2;		// Complete
				progressname = "Processing Cancelled";
				total=-1;
				critsec.Unlock();
				fclose(filehd);
				return(FALSE);
			}
			critsec.Unlock();
			update=1000;			// 1000 lines per update
		}
		update--;

		fgets(inputline,1024,filehd);
		inputstring=inputline;
		if(inputstring.GetLength()>2)
		{
			if(inputstring.Find("Scan")!=-1)
			{
				if(yaxis==0)
				{
					sscanf(inputline, "Scan\t\t%f", &yvalue);
					y=(DWORD)(((yvalue-yvalues[0])/ystepsize)+0.5f);
					if(y<0) y=0;
					if(y>=numy) y=numy-1;
					ycounts[y]++;
				}
			}
			else if(inputstring.Find("Retention")!=-1)
			{
				if(yaxis!=0)
				{
					sscanf(inputline, "Retention Time\t%f", &yvalue);
					y=(DWORD)(((yvalue-yvalues[0])/ystepsize)+0.5f);
					if(y<0) y=0;
					if(y>=numy) y=numy-1;
					ycounts[y]++;
				}
			}
			else if(sscanf(inputline, "%f\t%f", &xvalue, &zvalue)==2)
			{
				// Ok, here's where we sort 'em out - we have the present x,y,z
				x=(DWORD)(((xvalue-xvalues[0])/xstepsize)+0.5f);
				if(zvalue>0)	// <=0 is compressed data
				{
					if(x<0) x=0;
					if(x>=numx) x=numx-1;
					zvalues[(numx*y)+x]+=zvalue;
					zcounts[(numx*y)+x]++;
				}
			}
		}
	}

	fclose(filehd);

	critsec.Lock();
	progressname = "Reading Complete";
	total=-1;
	critsec.Unlock();

	return(TRUE);
}

BOOL CDataProcessing::Manipulate()
{
	// We have the x,y,z matrix set up, but need to average based on the x,y,z counts matrix

	critsec.Lock();
	progressname = "Integrating...";
	total=-1;
	critsec.Unlock();

	DWORD x,y;

	if(integrate==FALSE)
		// We need to average m/z as well as y values
	{
		for(y=0; y<numy; y++)
		{
			for(x=0; x<numx; x++)
			{
				if(zcounts[(numx*y)+x]!=0)
					zvalues[(numx*y)+x]/=zcounts[(numx*y)+x];
			}
		}
	}
	else
		// we only need to average when multiple yvalues
	{
		for(y=0; y<numy; y++)
		{
			if(ycounts[y]>1)
			{
				for(x=0; x<numx; x++)
				{
					zvalues[(numx*y)+x]/=ycounts[y];
				}
			}
		}
	}

	if(normalise)
	{
		// We need to normalise to the largest absolute value = 1.0
		DWORD c;
		double max=0;

		for(c=0; c<(numy*numx); c++)
			if(fabs(zvalues[c])>max) max=fabs(zvalues[c]);
		if(max>0)
		{
			for(c=0; c<(numy*numx); c++)
				zvalues[c]/=(float)max;
		}
	}

	critsec.Lock();
	progressname = "Integrating Complete";
	total=-1;
	critsec.Unlock();

	return(TRUE);
}

BOOL CDataProcessing::WriteFile()
{
	// We write out the averaged x,y,z matrix

	// Get output file name

	CString filename;

	critsec.Lock();
	workerflag=1;		// Working
	progressname = "Waiting for user input";
	total=-1;
	filename = inputfilename;
	critsec.Unlock();

	filename.Truncate(filename.Find('.'));
	filename+=".csv";

	static char BASED_CODE outfilter[] = "CSV Files (*.csv)|*.csv|Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";
	CFileDialog outfilebox(FALSE, "*.csv", filename, OFN_OVERWRITEPROMPT , outfilter);

	outfilebox.m_ofn.lpstrTitle="Output Data";
	if(outfilebox.DoModal()==IDOK)
	{
		filename=outfilebox.GetPathName();
	}
	else
	{
		critsec.Lock();
		workerflag=2;		// Complete
		progressname = "Processing Cancelled";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}

	critsec.Lock();
	if(workerflag<0)
	{
		workerflag=2;		// Complete
		progressname = "Processing Cancelled";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}
	critsec.Unlock();

	// Open output file

	FILE *filehd;

	filehd=fopen(filename, "wt");
	if(filehd==NULL)
	{
		MessageBox(NULL, "Couldn't open output file - aborted!", "Processing Error", MB_OK);

		critsec.Lock();
		workerflag=2;		// Complete
		progressname = "Processing Write Error";
		total=-1;
		critsec.Unlock();
		return(FALSE);
	}

	critsec.Lock();
	inputfilename = filename;
	progressname = "Writing...";
	total=(float)numx;
	present=0;
	critsec.Unlock();

	// Write x,y,z values

	DWORD x,y;

	if(yaxis==0) fprintf(filehd, "ScanNum->");
	else fprintf(filehd, "RetentionTime->");
	for(y=0; y<numy; y++)
	{
		fprintf(filehd, ",%f", yvalues[y]);
	}

	for(x=0; x<numx; x++)
	{
		critsec.Lock();
		present=(float)x;
		if(workerflag<0)
		{
			workerflag=2;		// Complete
			progressname = "Processing Cancelled";
			total=-1;
			critsec.Unlock();
			fclose(filehd);
			return(FALSE);
		}
		critsec.Unlock();

		fprintf(filehd, "\n%f", xvalues[x]);
		for(y=0; y<numy; y++)
		{
			fprintf(filehd, ",%f", zvalues[(numx*y)+x]);
		}
	}

	fprintf(filehd, "\n");

	fclose(filehd);

	critsec.Lock();
	progressname = "Writing Complete";
	total=-1;
	critsec.Unlock();

	return(TRUE);
}
